Index: lib/libcrypt/tests/crypt_tests.c
===================================================================
--- lib/libcrypt/tests/crypt_tests.c	(revision 253339)
+++ lib/libcrypt/tests/crypt_tests.c	(working copy)
@@ -43,7 +43,7 @@
 
 /*
  * This function must not do anything except enumerate
- * the test cases, else atf-run is likely to be upset.
+ * the test cases, per atf-c-api(3).
  */
 ATF_TP_ADD_TCS(tp)
 {
Index: tools/build/mk/OptionalObsoleteFiles.inc
===================================================================
--- tools/build/mk/OptionalObsoleteFiles.inc	(revision 253339)
+++ tools/build/mk/OptionalObsoleteFiles.inc	(working copy)
@@ -69,15 +69,7 @@
 .endif
 
 .if ${MK_ATF} == no
-OLD_DIRS+=etc/atf
-OLD_FILES+=etc/atf/FreeBSD.conf
-OLD_FILES+=etc/atf/atf-run.hooks
-OLD_FILES+=etc/atf/common.conf
-OLD_FILES+=usr/bin/atf-config
-OLD_FILES+=usr/bin/atf-report
-OLD_FILES+=usr/bin/atf-run
 OLD_FILES+=usr/bin/atf-sh
-OLD_FILES+=usr/bin/atf-version
 OLD_DIRS+=usr/include/atf-c
 OLD_FILES+=usr/include/atf-c/build.h
 OLD_FILES+=usr/include/atf-c/check.h
@@ -110,7 +102,6 @@
 OLD_FILES+=usr/lib/libatf-c.a
 OLD_FILES+=usr/libexec/atf-check
 OLD_DIRS+=usr/share/atf
-OLD_FILES+=usr/share/atf/atf-run.hooks
 OLD_FILES+=usr/share/atf/libatf-sh.subr
 OLD_DIRS+=usr/share/doc/atf
 OLD_FILES+=usr/share/doc/atf/AUTHORS
@@ -117,28 +108,42 @@
 OLD_FILES+=usr/share/doc/atf/COPYING
 OLD_FILES+=usr/share/doc/atf/NEWS
 OLD_FILES+=usr/share/doc/atf/README
-OLD_DIRS+=usr/share/examples/atf
-OLD_FILES+=usr/share/examples/atf/atf-run.hooks
-OLD_FILES+=usr/share/examples/atf/tests-results.css
 OLD_FILES+=usr/share/man/man1/atf-check.1.gz
-OLD_FILES+=usr/share/man/man1/atf-config.1.gz
-OLD_FILES+=usr/share/man/man1/atf-report.1.gz
-OLD_FILES+=usr/share/man/man1/atf-run.1.gz
 OLD_FILES+=usr/share/man/man1/atf-sh.1.gz
 OLD_FILES+=usr/share/man/man1/atf-test-program.1.gz
-OLD_FILES+=usr/share/man/man1/atf-version.1.gz
 OLD_FILES+=usr/share/man/man3/atf-c-api.3.gz
 OLD_FILES+=usr/share/man/man3/atf-c++-api.3.gz
 OLD_FILES+=usr/share/man/man3/atf-sh-api.3.gz
 OLD_FILES+=usr/share/man/man4/atf-test-case.4.gz
+OLD_FILES+=usr/share/mk/atf.test.mk
+.endif
+# The following correspond to the deprecated ATF tools.  These were once
+# installed as part of the base system, but they have been deleted in
+# favor of Kyua (to be installed from ports).
+OLD_FILES+=etc/atf/FreeBSD.conf
+OLD_FILES+=etc/atf/atf-run.hooks
+OLD_FILES+=etc/atf/common.conf
+OLD_DIRS+=etc/atf
+OLD_FILES+=usr/bin/atf-config
+OLD_FILES+=usr/bin/atf-report
+OLD_FILES+=usr/bin/atf-run
+OLD_FILES+=usr/bin/atf-version
+OLD_FILES+=usr/share/atf/atf-run.hooks
+OLD_FILES+=usr/share/examples/atf/atf-run.hooks
+OLD_FILES+=usr/share/examples/atf/tests-results.css
+OLD_DIRS+=usr/share/examples/atf
+OLD_FILES+=usr/share/man/man1/atf-config.1.gz
+OLD_FILES+=usr/share/man/man1/atf-report.1.gz
+OLD_FILES+=usr/share/man/man1/atf-run.1.gz
+OLD_FILES+=usr/share/man/man1/atf-version.1.gz
 OLD_FILES+=usr/share/man/man5/atf-formats.5.gz
 OLD_FILES+=usr/share/man/man7/atf.7.gz
-OLD_FILES+=usr/share/mk/atf.test.mk
+OLD_FILES+=usr/share/xml/atf/tests-results.dtd
 OLD_DIRS+=usr/share/xml/atf
-OLD_FILES+=usr/share/xml/atf/tests-results.dtd
+OLD_DIRS+=usr/share/xml
+OLD_FILES+=usr/share/xsl/atf/tests-results.xsl
 OLD_DIRS+=usr/share/xsl/atf
-OLD_FILES+=usr/share/xsl/atf/tests-results.xsl
-.endif
+OLD_DIRS+=usr/share/xsl
 
 .if ${MK_ATM} == no
 OLD_FILES+=rescue/atmconfig
Index: usr.bin/atf/Makefile
===================================================================
--- usr.bin/atf/Makefile	(revision 253339)
+++ usr.bin/atf/Makefile	(working copy)
@@ -25,10 +25,6 @@
 #
 # $FreeBSD$
 
-SUBDIR=	atf-config \
-	atf-report \
-	atf-run \
-	atf-sh \
-	atf-version
+SUBDIR=	atf-sh
 
 .include <bsd.subdir.mk>
Index: usr.bin/atf/Makefile.inc
===================================================================
--- usr.bin/atf/Makefile.inc	(revision 253339)
+++ usr.bin/atf/Makefile.inc	(working copy)
@@ -2,7 +2,5 @@
 
 ATF=		${.CURDIR}/../../../contrib/atf
 
-CFLAGS+=	-DGDB=\"gdb\"
-
 BINDIR?=	/usr/bin
 WARNS?=		3
Index: usr.bin/atf/atf-config/Makefile
===================================================================
--- usr.bin/atf/atf-config/Makefile	(revision 253339)
+++ usr.bin/atf/atf-config/Makefile	(working copy)
@@ -1,42 +0,0 @@
-#-
-# Copyright (c) 2011 Google, Inc.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-.include <bsd.init.mk>
-
-.PATH:		${ATF}/atf-config
-
-PROG_CXX=	atf-config
-SRCS=		atf-config.cpp
-MAN=		atf-config.1
-
-CFLAGS+=	-DHAVE_CONFIG_H
-CFLAGS+=	-I${ATF}
-
-DPADD+=		${LIBATF_C} ${LIBATF_CXX}
-LDADD+=		-latf-c++ -latf-c
-
-.include <bsd.prog.mk>
Index: usr.bin/atf/atf-report/Makefile
===================================================================
--- usr.bin/atf/atf-report/Makefile	(revision 253339)
+++ usr.bin/atf/atf-report/Makefile	(working copy)
@@ -1,42 +0,0 @@
-#-
-# Copyright (c) 2011 Google, Inc.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-.include <bsd.init.mk>
-
-.PATH:		${ATF}/atf-report
-
-PROG_CXX=	atf-report
-SRCS=		atf-report.cpp reader.cpp
-MAN=		atf-report.1
-
-CFLAGS+=	-DHAVE_CONFIG_H
-CFLAGS+=	-I${ATF}
-
-DPADD+=		${LIBATF_C} ${LIBATF_CXX}
-LDADD+=		-latf-c++ -latf-c
-
-.include <bsd.prog.mk>
Index: usr.bin/atf/atf-run/Makefile
===================================================================
--- usr.bin/atf/atf-run/Makefile	(revision 253339)
+++ usr.bin/atf/atf-run/Makefile	(working copy)
@@ -1,44 +0,0 @@
-#-
-# Copyright (c) 2011 Google, Inc.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-.include <bsd.init.mk>
-
-.PATH:		${ATF}/atf-run
-
-PROG_CXX=	atf-run
-SRCS=		atf-run.cpp atffile.cpp config.cpp fs.cpp io.cpp requirements.cpp \
-		signals.cpp test-program.cpp timer.cpp user.cpp
-MAN=		atf-run.1
-
-CFLAGS+=	-DHAVE_CONFIG_H
-CFLAGS+=	-I${ATF}
-CFLAGS+=	-I${.CURDIR}/../../lib/libatf-c
-
-DPADD+=		${LIBATF_C} ${LIBATF_CXX}
-LDADD+=		-latf-c++ -latf-c
-
-.include <bsd.prog.mk>
Index: usr.bin/atf/atf-version/Makefile
===================================================================
--- usr.bin/atf/atf-version/Makefile	(revision 253339)
+++ usr.bin/atf/atf-version/Makefile	(working copy)
@@ -1,52 +0,0 @@
-#-
-# Copyright (c) 2011 Google, Inc.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-.include <bsd.init.mk>
-
-.PATH:		${ATF}/atf-version
-
-PROG_CXX=	atf-version
-SRCS=		atf-version.cpp revision.h
-MAN=		atf-version.1
-
-CFLAGS+=	-DHAVE_CONFIG_H
-CFLAGS+=	-I${ATF}
-CFLAGS+=	-I${.CURDIR}/../../lib/libatf-c
-CFLAGS+=	-I${.CURDIR}
-CFLAGS+=	-I.
-
-CLEANFILES+=	revision.h
-revision.h:
-	@sh ${ATF}/atf-version/generate-revision.sh \
-		-o ${.TARGET} \
-		-r ${ATF} \
-		-v `awk '$$2 == "VERSION" { print $$3 }' ${ATF}/bconfig.h`
-
-DPADD+=		${LIBATF_C} ${LIBATF_CXX}
-LDADD+=		-latf-c++ -latf-c
-
-.include <bsd.prog.mk>
Index: etc/Makefile
===================================================================
--- etc/Makefile	(revision 253339)
+++ etc/Makefile	(working copy)
@@ -216,9 +216,6 @@
 		echo "./etc/spwd.db type=file mode=0600 uname=root gname=wheel"; \
 	) | ${METALOG.add}
 .endif
-.if ${MK_ATF} != "no"
-	${_+_}cd ${.CURDIR}/atf; ${MAKE} install
-.endif
 .if ${MK_BLUETOOTH} != "no"
 	${_+_}cd ${.CURDIR}/bluetooth; ${MAKE} install
 .endif
Index: etc/atf/FreeBSD.conf
===================================================================
--- etc/atf/FreeBSD.conf	(revision 253339)
+++ etc/atf/FreeBSD.conf	(working copy)
@@ -1,12 +0,0 @@
-Content-Type: application/X-atf-config; version="1"
-
-# $FreeBSD$
-#
-# Configuration file for the FreeBSD test suite.
-#
-# See atf-formats(5) for details on the syntax of this file and tests(7) for
-# details on the FreeBSD test suite.
-#
-
-#variable1 = value1
-#variable2 = value2
Index: etc/atf/Makefile
===================================================================
--- etc/atf/Makefile	(revision 253339)
+++ etc/atf/Makefile	(working copy)
@@ -1,39 +0,0 @@
-#-
-# Copyright (c) 2011 Google, Inc.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-ATF=		${.CURDIR}/../../contrib/atf
-
-.PATH:		${ATF}/atf-run/sample
-
-NO_OBJ=
-
-FILESGROUPS=	ETC
-
-ETCDIR=		/etc/atf
-ETC=		FreeBSD.conf atf-run.hooks common.conf
-
-.include <bsd.prog.mk>
Index: etc/atf/common.conf
===================================================================
--- etc/atf/common.conf	(revision 253339)
+++ etc/atf/common.conf	(working copy)
@@ -1,12 +0,0 @@
-Content-Type: application/X-atf-config; version="1"
-
-# $FreeBSD$
-#
-# Sample configuration file for properties affecting all test suites.
-#
-
-# When running the test suite as root, some tests require to switch to
-# an unprivileged user to perform extra checks.  Set this variable to
-# the user you want to use in those cases.  If not set, those tests will
-# be skipped.
-unprivileged-user = "_atf"
Index: share/examples/Makefile
===================================================================
--- share/examples/Makefile	(revision 253339)
+++ share/examples/Makefile	(working copy)
@@ -241,9 +241,6 @@
 
 .if ${SHARED} != "symlinks"
 SUBDIR=	smbfs
-.if ${MK_ATF} != "no"
-SUBDIR+=atf
-.endif
 .if ${MK_IPFILTER} != "no"
 SUBDIR+=ipfilter
 .endif
Index: share/examples/atf/Makefile
===================================================================
--- share/examples/atf/Makefile	(revision 253339)
+++ share/examples/atf/Makefile	(working copy)
@@ -1,39 +0,0 @@
-#-
-# Copyright (c) 2011 Google, Inc.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-ATF=		${.CURDIR}/../../../contrib/atf
-
-.PATH:		${ATF}/atf-report
-.PATH:		${ATF}/atf-run/sample
-
-NO_OBJ=
-
-FILESDIR=	${SHAREDIR}/examples/atf
-FILES=		atf-run.hooks \
-		tests-results.css
-
-.include <bsd.prog.mk>
Index: share/mk/atf.test.mk
===================================================================
--- share/mk/atf.test.mk	(revision 253339)
+++ share/mk/atf.test.mk	(working copy)
@@ -51,98 +51,4 @@
 .endfor
 .endif
 
-ATFFILE?= auto
-
-.if ${ATFFILE:tl} != "no"
-FILES+=	Atffile
-FILESDIR_Atffile= ${TESTSDIR}
-
-.if ${ATFFILE:tl} == "auto"
-CLEANFILES+= Atffile Atffile.tmp
-
-Atffile: Makefile
-	@{ echo 'Content-Type: application/X-atf-atffile; version="1"'; \
-	echo; \
-	echo '# Automatically generated by atf-test.mk.'; \
-	echo; \
-	echo 'prop: test-suite = "'`uname -o`'"'; \
-	echo; \
-	for tp in ${ATF_TESTS}; do \
-	    echo "tp: $${tp}"; \
-	done; } >Atffile.tmp
-	@mv Atffile.tmp Atffile
-.endif
-.endif
-
-# Generate support variables for atf-test.
-#
-# atf-test can only work for native builds, i.e. a build host of a particular
-# OS building a release for the same OS version and architecture. The target
-# runs ATF, which is on the build host, and the tests execute code built for
-# the target host.
-#
-# Due to the dependencies of the binaries built by the source tree and how they
-# are used by tests, it is highly possible for a execution of "make test" to
-# report bogus results unless the new binaries are put in place.
-
-# XXX (gcooper): Executing ATF from outside the source tree is improper; it
-# should be built as part of the OS toolchain build for the host OS and
-# executed from there.
-ATF_PATH+= ${DESTDIR}/bin ${DESTDIR}/sbin ${DESTDIR}/usr/bin ${DESTDIR}/usr/sbin
-TESTS_ENV+= PATH=${ATF_PATH:ts:}:${PATH}
-
-ATF_BUILD_CC?= ${DESTDIR}/usr/bin/cc
-ATF_BUILD_CPP?= ${DESTDIR}/usr/bin/cpp
-ATF_BUILD_CXX?= ${DESTDIR}/usr/bin/c++
-ATF_CONFDIR?= ${DESTDIR}/etc
-ATF_INCLUDEDIR?= ${DESTDIR}/usr/include
-ATF_LIBDIR?= ${DESTDIR}/usr/lib
-ATF_LIBEXECDIR?= ${DESTDIR}/usr/libexec
-ATF_PKGDATADIR?= ${DESTDIR}/usr/share/atf
-ATF_SHELL?= ${DESTDIR}/bin/sh
-LD_LIBRARY_PATH?= ${TESTS_LD_LIBRARY_PATH:tW:S/ /:/g}
-
-ATF_ENV_VARS= \
-	ATF_BUILD_CC \
-	ATF_BUILD_CPP \
-	ATF_BUILD_CXX \
-	ATF_CONFDIR \
-	ATF_INCLUDEDIR \
-	ATF_LIBDIR \
-	ATF_LIBEXECDIR \
-	ATF_PKGDATADIR \
-	ATF_SHELL \
-
-.for v in ${ATF_ENV_VARS}
-.if !empty($v)
-TESTS_ENV+= $v=${$v}
-.endif
-.endfor
-
-_TESTS_FIFO= ${.OBJDIR}/atf-run.fifo
-_TESTS_LOG= ${.OBJDIR}/atf-run.log
-CLEANFILES+= ${_TESTS_FIFO} ${_TESTS_LOG}
-
-ATF_BIN?= ${DESTDIR}/usr/bin
-ATF_REPORT?= ${ATF_BIN}/atf-report
-ATF_RUN?= ${ATF_BIN}/atf-run
-
-.PHONY: realtest
-realtest:
-.if defined(TESTSDIR)
-	@set -e; \
-	cd ${DESTDIR}${TESTSDIR}; \
-	rm -f ${_TESTS_FIFO}; \
-	mkfifo ${_TESTS_FIFO}; \
-	tee ${_TESTS_LOG} < ${_TESTS_FIFO} | ${TESTS_ENV} ${ATF_REPORT} & \
-	set +e; \
-	${TESTS_ENV} ${ATF_RUN} >> ${_TESTS_FIFO}; \
-	result=$${?}; \
-	wait; \
-	rm -f ${_TESTS_FIFO}; \
-	echo; \
-	echo "*** The verbatim output of atf-run has been saved to ${_TESTS_LOG}"; \
-	exit $${result}
-.endif
-
 .include <bsd.test.mk>
Index: share/atf/Makefile
===================================================================
--- share/atf/Makefile	(revision 253339)
+++ share/atf/Makefile	(working copy)
@@ -1,37 +0,0 @@
-#-
-# Copyright (c) 2012 EMC Corporation.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-ATF=		${.CURDIR}/../../contrib/atf
-
-.PATH:		${ATF}/atf-run/sample
-
-NO_OBJ=
-
-FILESDIR=	${SHAREDIR}/atf
-FILES=		atf-run.hooks
-
-.include <bsd.prog.mk>
Index: share/Makefile
===================================================================
--- share/Makefile	(revision 253339)
+++ share/Makefile	(working copy)
@@ -5,8 +5,7 @@
 
 # Do not include `info' in the SUBDIR list, it is handled separately.
 
-SUBDIR=	${_atf} \
-	${_colldef} \
+SUBDIR=	${_colldef} \
 	${_dict} \
 	${_doc} \
 	dtrace \
@@ -27,16 +26,10 @@
 	tabset \
 	termcap \
 	${_timedef} \
-	xml \
-	xsl \
 	${_zoneinfo}
 
 # NB: keep these sorted by MK_* knobs
 
-.if ${MK_ATF} != "no"
-_atf=		atf
-.endif
-
 .if ${MK_BSNMP} != "no"
 _snmp=		snmp
 .endif
Index: share/xml/Makefile
===================================================================
--- share/xml/Makefile	(revision 253339)
+++ share/xml/Makefile	(working copy)
@@ -1,36 +0,0 @@
-#-
-# Copyright (c) 2012 EMC Corporation.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-.include <bsd.own.mk>
-
-SUBDIR+=	${_atf}
-
-.if ${MK_ATF} != "no"
-_atf=		atf
-.endif
-
-.include <bsd.subdir.mk>
Index: share/xml/Makefile.inc
===================================================================
--- share/xml/Makefile.inc	(revision 253339)
+++ share/xml/Makefile.inc	(working copy)
@@ -1,30 +0,0 @@
-#-
-# Copyright (c) 2012 EMC Corporation.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-BINDIR?=	${SHAREDIR}/xml
-
-# vim: syntax=make
Index: share/xml/atf/Makefile
===================================================================
--- share/xml/atf/Makefile	(revision 253339)
+++ share/xml/atf/Makefile	(working copy)
@@ -1,39 +0,0 @@
-#-
-# Copyright (c) 2011 Google, Inc.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-ATF=		${.CURDIR}/../../../contrib/atf
-
-.PATH:		${ATF}/atf-report
-
-NO_OBJ=
-
-FILESGROUPS=    XML
-
-XMLDIR=		${SHAREDIR}/xml/atf
-XML=		tests-results.dtd
-
-.include <bsd.prog.mk>
Index: share/xsl/Makefile
===================================================================
--- share/xsl/Makefile	(revision 253339)
+++ share/xsl/Makefile	(working copy)
@@ -1,36 +0,0 @@
-#-
-# Copyright (c) 2012 EMC Corporation.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-.include <bsd.own.mk>
-
-SUBDIR+=	${_atf}
-
-.if ${MK_ATF} != "no"
-_atf=		atf
-.endif
-
-.include <bsd.subdir.mk>
Index: share/xsl/Makefile.inc
===================================================================
--- share/xsl/Makefile.inc	(revision 253339)
+++ share/xsl/Makefile.inc	(working copy)
@@ -1,30 +0,0 @@
-#-
-# Copyright (c) 2012 EMC Corporation.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-BINDIR?=	${SHAREDIR}/xsl
-
-# vim: syntax=make
Index: share/xsl/atf/Makefile
===================================================================
--- share/xsl/atf/Makefile	(revision 253339)
+++ share/xsl/atf/Makefile	(working copy)
@@ -1,39 +0,0 @@
-#-
-# Copyright (c) 2011 Google, Inc.
-# All rights reserved.
-#
-# Redistribution and use in source and binary forms, with or without
-# modification, are permitted provided that the following conditions
-# are met:
-# 1. Redistributions of source code must retain the above copyright
-#    notice, this list of conditions and the following disclaimer.
-# 2. Redistributions in binary form must reproduce the above copyright
-#    notice, this list of conditions and the following disclaimer in the
-#    documentation and/or other materials provided with the distribution.
-#
-# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
-# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
-# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
-# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
-# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
-# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
-# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
-# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
-# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
-# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
-# SUCH DAMAGE.
-#
-# $FreeBSD$
-
-ATF=		${.CURDIR}/../../../contrib/atf
-
-.PATH:		${ATF}/atf-report
-
-NO_OBJ=
-
-FILESGROUPS=    XSL
-
-XSLDIR=		${SHAREDIR}/xsl/atf
-XSL=		tests-results.xsl
-
-.include <bsd.prog.mk>