Index: en_US.ISO8859-1/books/porters-handbook/book.xml
===================================================================
--- en_US.ISO8859-1/books/porters-handbook/book.xml	(revision 43200)
+++ en_US.ISO8859-1/books/porters-handbook/book.xml	(working copy)
@@ -8142,9 +8142,9 @@
       <para>The <varname>USE_SDL</varname> variable is used to
 	autoconfigure the dependencies for ports which use an SDL
 	based library like
-	<package>devel/sdl12</package> and <package>x11-toolkits/sdl_gui</package>.</para>
+	<package>devel/sdl12</package> and <package>graphics/sdl_image</package>.</para>
 
-      <para>The following SDL libraries are recognized at the
+      <para>The following SDL libraries for version 1.2 are recognized at the
 	moment:</para>
 
       <itemizedlist>
@@ -8153,11 +8153,11 @@
 	</listitem>
 
 	<listitem>
-	  <para>gfx: <package>graphics/sdl_gfx</package></para>
+	  <para>console: <package>devel/sdl_console</package></para>
 	</listitem>
 
 	<listitem>
-	  <para>gui: <package>x11-toolkits/sdl_gui</package></para>
+	  <para>gfx: <package>graphics/sdl_gfx</package></para>
 	</listitem>
 
 	<listitem>
@@ -8165,10 +8165,6 @@
 	</listitem>
 
 	<listitem>
-	  <para>ldbad: <package>devel/sdl_ldbad</package></para>
-	</listitem>
-
-	<listitem>
 	  <para>mixer: <package>audio/sdl_mixer</package></para>
 	</listitem>
 
@@ -8181,6 +8177,10 @@
 	</listitem>
 
 	<listitem>
+	  <para>pango: <package>x11-toolkits/sdl_pango</package></para>
+	</listitem>
+
+	<listitem>
 	  <para>sound: <package>audio/sdl_sound</package></para>
 	</listitem>
 
@@ -8189,6 +8189,35 @@
 	</listitem>
       </itemizedlist>
 
+      <para>The following SDL libraries for version 2.0 are recognized at the
+	moment:</para>
+
+      <itemizedlist>
+	<listitem>
+	  <para>sdl: <package>devel/sdl20</package></para>
+	</listitem>
+
+	<listitem>
+	  <para>gfx: <package>graphics/sdl2_gfx</package></para>
+	</listitem>
+
+	<listitem>
+	  <para>image: <package>graphics/sdl2_image</package></para>
+	</listitem>
+
+	<listitem>
+	  <para>mixer: <package>audio/sdl2_mixer</package></para>
+	</listitem>
+
+	<listitem>
+	  <para>net: <package>net/sdl2_net</package></para>
+	</listitem>
+
+	<listitem>
+	  <para>ttf: <package>graphics/sdl2_ttf</package></para>
+	</listitem>
+      </itemizedlist>
+
       <para>Therefore, if a port has a dependency on
 	<package>net/sdl_net</package> and
 	<package>audio/sdl_mixer</package>,
@@ -8202,8 +8231,8 @@
 	and <package>audio/sdl_mixer</package>, is
 	automatically added as well.</para>
 
-      <para>If you use <varname>USE_SDL</varname>, it will
-	automatically:</para>
+      <para>If you use <varname>USE_SDL</varname> with entries using
+      SDL 1.2, it will automatically:</para>
 
       <itemizedlist>
 	<listitem>
@@ -8223,6 +8252,27 @@
 	</listitem>
       </itemizedlist>
 
+      <para>If you use <varname>USE_SDL</varname> with entries using
+      SDL 2.0, it will automatically:</para>
+
+      <itemizedlist>
+	<listitem>
+	  <para>Add a dependency on
+	    <application>sdl2-config</application> to
+	    <varname>BUILD_DEPENDS</varname></para>
+	</listitem>
+
+	<listitem>
+	  <para>Add the variable <varname>SDL2_CONFIG</varname> to
+	    <varname>CONFIGURE_ENV</varname></para>
+	</listitem>
+
+	<listitem>
+	  <para>Add the dependencies of the selected libraries to the
+	    <varname>LIB_DEPENDS</varname></para>
+	</listitem>
+      </itemizedlist>
+
       <para>To check whether an SDL library is available, you can do
 	it with the <varname>WANT_SDL</varname> variable:</para>
 
Index: en_US.ISO8859-1/books/porters-handbook/uses.xml
===================================================================
--- en_US.ISO8859-1/books/porters-handbook/uses.xml	(revision 43200)
+++ en_US.ISO8859-1/books/porters-handbook/uses.xml	(working copy)
@@ -270,3 +270,13 @@
     another, but largely is used for building zenoss related zenpack
     ports.</entry>
 </row>
+
+<row>
+  <entry><literal>zope</literal></entry>
+  <entry>(none)</entry>
+  <entry>Implies that the port uses
+    <filename role="package">www/zope</filename> in one way or another,
+    but is largely used for building zope related ports.
+    <varname>ZOPE_VERSION</varname> can be used by a port to indicate that
+    a specific version of zope shall be used.</entry>
+</row>